//lcd.c
#include <string.h>
#include "lcd.h"

unsigned long data;
void Delay (unsigned long a) { while (--a!=0); }

void E_Pulse()
{
  IO0SET_bit.P0_29 = 1; //set E to high
  Delay(10);
  IO0CLR_bit.P0_29 = 1; //set E to low
}

void LCDInit()
{
  //first set D4, D5, D6, D7, LCD_LIGHT, RS, RW, E to output ports
  IO0DIR_bit.P0_4 = 1;
  IO0DIR_bit.P0_5 = 1;
  IO0DIR_bit.P0_6 = 1;
  IO0DIR_bit.P0_7 = 1;
  IO0DIR_bit.P0_10 = 1;
  IO0DIR_bit.P0_28 = 1;
  IO0DIR_bit.P0_29 = 1;
  IO0DIR_bit.P0_30 = 1;


  //LCD initialization
  //step by step from LCD Display data sheed
  IO0CLR_bit.P0_28 = 1;  //set RS port to 0
  IO0CLR_bit.P0_29 = 1;  //set R/W port to 0
  IO0CLR_bit.P0_30 = 1;  //set E port to 0

  Delay(110000);        //delay ~110ms

  IO0SET_bit.P0_4 = 1;   //set D4 port to 1
  IO0SET_bit.P0_5 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  Delay(10000);         //delay ~10ms


  IO0SET_bit.P0_4 = 1;   //set D4 port to 1
  IO0SET_bit.P0_5 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  Delay(10000);         //delay ~10ms


  IO0SET_bit.P0_4 = 1;   //set D4 port to 1
  IO0SET_bit.P0_5 = 1;   //set D5 port to 1
  E_Pulse();            //high->low to E port (pulse)
  Delay(10000);         //delay ~10ms

  IO0SET_bit.P0_5 = 1;   //set D5 port to 1
  IO0CLR_bit.P0_4 = 1;   //set D4 port to 0
  E_Pulse();            //high->low to E port (pulse)

}

void LCDSendCommand(unsigned long a)
{
  IO0CLR_bit.P0_30 = 1;                    //set RW port to 0

  Delay(2000);                            //delay for LCD char ~2ms

  data = 0xffffff0f | a;                  //get high 4 bits
  IO0CLR |= 0x000000f0;                    //clear D4-D7
  IO0SET = (IO0SET | 0x000000f0) & data;    //set D4-D7
  IO0CLR_bit.P0_28 = 1;                    //set RS port to 0 -> display set to comand mode
  E_Pulse();                              //pulse to set d4-d7 bits


  data = (a << 4) & 0x000000f0;   	  //get low 4 bits
  IO0CLR |= 0x000000f0;                    //clear D4-D7
  IO0SET = (IO0SET & 0xffffff0f) | data;	  //set D4-D7 (only PORTC4-PORTC7)
  IO0CLR_bit.P0_28 = 1;                    //set RS port to 0 -> display set to command mode
  E_Pulse();                              //pulse to set d4-d7 bits

}

void LCDSendChar(unsigned long a)
{
  IO0CLR_bit.P0_30 = 1;                    //set RW port to 0

  Delay(2000);                            //delay for LCD char ~2ms

  data = 0xffffff0f | a;                  //get high 4 bits
  IO0CLR |= 0x000000f0;                    //clear D4-D7
  IO0SET = (IO0SET | 0x000000f0) & data;    //set D4-D7
  IO0SET_bit.P0_28 = 1;                    //set RS port to 1 -> display set to data mode
  E_Pulse();                              //pulse to set d4-d7 bits

  data = (a << 4) & 0x000000f0;   	  //get low 4 bits
  IO0CLR |= 0x000000f0;                    //clear D4-D7
  IO0SET = (IO0SET & 0xffffff0f) | data;	  //set D4-D7 (only PORTC4-PORTC7)
  IO0SET_bit.P0_28 = 1;                    //set RS port to 1 -> display set to data mode
  E_Pulse();                              //pulse to set d4-d7 bits

}

void LCDSendTxt(char* a)
{
  for(int i=0; i<strlen(a); i++)
  {
    LCDSendChar(a[i]);
  }
}

